// (c) Copyright 2013 Cloudera, Inc. All rights reserved.

define(["cloudera/search/enableRecentFilters","cloudera/Util","underscore"],function(e,t,n){describe("enableRecentFilters",function(){var r,i,s,o=function(){e(r,"getRecentFilters","updateRecentFilters",i)},u=function(e,t,n){return{filter:{displayName:e,propertyName:e},compareType:{displayName:t},value:n,values:n}};beforeEach(function(){jasmine.Ajax.useMock(),r={appliedFilters:jasmine.createSpy("appliedFilters").andReturn([])},r.appliedFilters.removeAll=jasmine.createSpy("removeAll"),i={findFilter:jasmine.createSpy("findFilter"),applyFilter:jasmine.createSpy("applyFilter")},s=n.map(n.range(5),function(e){return JSON.stringify([u("filter"+e,"EQ","value"+e)])})}),it("modifies the viewModel with recent filters properties",function(){o(),expect(r.supportRecent).toBeTruthy(),expect(r.recentFilters).toBeDefined(),expect(r.getRecentFilters).toBeDefined(),expect(r.updateRecentFilters).toBeDefined(),expect(r.selectRecentFilter).toBeDefined(),expect(r.search).toBeDefined()}),it("updates recent filters immediately on invoke",function(){o();var e=mostRecentAjaxRequest();expect(e.url).toEqual("getRecentFilters"),e.response({status:200,responseText:JSON.stringify(s)});var t=r.recentFilters();expect(t.length).toEqual(5),expect(t[0].prettyPrinted).toEqual("filter0 EQ value0"),expect(t[1].prettyPrinted).toEqual("filter1 EQ value1"),expect(t[2].prettyPrinted).toEqual("filter2 EQ value2"),expect(t[3].prettyPrinted).toEqual("filter3 EQ value3"),expect(t[4].prettyPrinted).toEqual("filter4 EQ value4")}),it("handles errors when getting recent filters",function(){spyOn(t,"filterError"),o();var e=mostRecentAjaxRequest();e.response({status:200,responseText:"Not a JSON string"}),expect(t.filterError).wasCalled()}),it("does not update if currently applied filters are empty",function(){o(),r.updateRecentFilters(),expect(r.appliedFilters).wasCalled();var e=mostRecentAjaxRequest();expect(e.url).not.toEqual("updateRecentFilters")}),it("updates recent with current filter and immediately fetches again",function(){o(),r.getRecentFilters=jasmine.createSpy("getRecentFilters"),r.appliedFilters.andReturn(["filter1","filter2"]),r.updateRecentFilters();var e=mostRecentAjaxRequest();expect(e.url).toEqual("updateRecentFilters");var n=t.unparam(e.params),i=JSON.parse(n.filters);expect(i.length).toEqual(2),expect(i[0]).toEqual("filter1"),expect(i[1]).toEqual("filter2"),e.response({status:200,responseText:""}),expect(r.getRecentFilters).wasCalled()}),it("searches when a recent filter is selected",function(){o(),r.appliedFilters.removeAll=jasmine.createSpy("removeAll");var e=[u("filter1","EQ","value1"),u("filter2","EQ","value2")];i.findFilter.andReturn("filter3"),r.search=jasmine.createSpy("search"),r.selectRecentFilter({filter:e}),expect(r.appliedFilters.removeAll).wasCalled(),expect(i.applyFilter.callCount).toEqual(2);var t=i.applyFilter.argsForCall[0];expect(t[0]).toEqual("filter3"),expect(t[1].displayName).toEqual("EQ"),expect(t[2]).toEqual("value1")}),it("wraps existing search functionality to update recent filters",function(){var e=jasmine.createSpy("oldSearch");r.search=e,o(),r.updateRecentFilters=jasmine.createSpy("updateRecentFilters"),r.search(),expect(r.updateRecentFilters).wasCalled(),expect(e).wasCalled()}),describe("prettyPrintFilter",function(){var t;beforeEach(function(){t=e.prettyPrintFilter}),it("should pretty print simple filter",function(){var e=[u("cat","EQ","pants")],n=t(e);expect(n).toEqual("cat EQ pants")}),it("should combine two clauses with AND",function(){var e=[u("cat","NEQ","pants"),u("doggy","EQ","hat")],n=t(e);expect(n).toEqual("cat NEQ pants AND doggy EQ hat")})}),describe("transformRecentFilters",function(){var t;beforeEach(function(){t=e.transformRecentFilters}),it("can interpret filters from the server correctly",function(){var e=JSON.stringify([u("cat","EQ","pants"),u("cat2","EQ","pants2")]),n=JSON.stringify([u("doggy","NEQ","hat")]),r=[e,n],i=t(r);expect(i.length).toEqual(2);var s=i[0];expect(s.filter).toBeDefined(),expect(s.filter.length).toEqual(2),expect(s.prettyPrinted).toEqual("cat EQ pants AND cat2 EQ pants2"),s=i[1],expect(s.filter).toBeDefined(),expect(s.filter.length).toEqual(1),expect(s.prettyPrinted).toEqual("doggy NEQ hat")})})})})